Summary: The Squid proxy caching server.
Name: squid
Version: 2.5.STABLE10
Release: 1.norlug
Epoch: 8
License: GPL
Group: System Environment/Daemons
URL: http://www.squid-cache.org
Source: http://www.squid-cache.org/Squid/v2/squid-%{version}.tar.bz2
Source1: http://www.squid-cache.org/Squid/FAQ/FAQ.sgml
Source2: squid.init
Source3: squid.logrotate
Source4: squid.sysconfig
# build-related patches
Patch0: squid-2.5.STABLE7-config.patch
Patch1: squid-2.5.STABLE7-build.patch

# my own sundry patches :)
# get rid of MS font references :-)
#Patch10: gopher.c-style.patch
#Patch11: ftp.c-style.patch
#Patch12: urn.c-style.patch

# upstream patches (major)

# upstream patches (medium)

BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: /sbin/chkconfig logrotate shadow-utils
Requires: bash >= 2.0
BuildPrereq: openjade linuxdoc-tools openldap-devel pam-devel
Obsoletes: squid-novm

%description
Squid is a high-performance proxy caching server for Web clients,
supporting FTP, gopher, and HTTP data objects. Unlike traditional
caching software, Squid handles all requests in a single,
non-blocking, I/O-driven process. Squid keeps meta data and especially
hot objects cached in RAM, caches DNS lookups, supports non-blocking
DNS lookups, and implements negative caching of failed requests.

Squid consists of a main server program squid, a Domain Name System
lookup program (dnsserver), a program for retrieving FTP data
(ftpget), and some management and client tools.

%prep
%setup -q
%patch0 -p1 -b .config
%patch1 -p1 -b .build

#%patch10
#%patch11
#%patch12

# Chip's sundry fixes/hacks:
# fix newline fuckup in makefile - somehow patch1 causes this
/usr/bin/dos2unix src/Makefile.in
chmod 664 src/Makefile.in
# kill M$ font styles in error pages
perl -pi -e 's|\<STYLE(.*)\<\/STYLE\>||;' errors/English/* src/*.c
#perl -pi -e 's|verdana|arial,helvetica|g' errors/English/* src/*.c

%build
# export CFLAGS=-fpie ; export LDFLAGS=-pie ; 
%configure \
   --exec_prefix=/usr \
   --bindir=/usr/sbin \
   --libexecdir=/usr/lib/squid \
   --localstatedir=/var \
   --sysconfdir=/etc/squid \
   --enable-poll \
   --enable-snmp \
   --enable-removal-policies="heap,lru" \
   --enable-storeio="aufs,coss,diskd,null,ufs" \
   --enable-ssl \
   --with-openssl=/usr/kerberos \
   --enable-delay-pools \
   --enable-linux-netfilter \
   --with-pthreads \
   --enable-basic-auth-helpers="LDAP,NCSA,PAM,SMB,SASL,MSNT"  \
   --enable-ntlm-auth-helpers="SMB,winbind" \
   --enable-external-acl-helpers="ip_user,ldap_group,unix_group,wbinfo_group,winbind_group" \
   --enable-auth="basic,ntlm" \
   --with-winbind-auth-challenge \
   --enable-useragent-log \
   --enable-referer-log \
   # --enable-icmp \

#export CFLAGS=-fpie ; export LDFLAGS=-pie ;
make

mkdir faq
cp $RPM_SOURCE_DIR/FAQ.sgml faq
cd faq 
sgml2html FAQ.sgml

#cd ..

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall  \
	sysconfdir=$RPM_BUILD_ROOT/etc/squid \
	localstatedir=$RPM_BUILD_ROOT/var \
	bindir=$RPM_BUILD_ROOT/usr/sbin \
	libexecdir=$RPM_BUILD_ROOT/usr/lib/squid

ln -s %{_datadir}/squid/errors/English $RPM_BUILD_ROOT/etc/squid/errors

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
install -m 755 $RPM_SOURCE_DIR/squid.init $RPM_BUILD_ROOT/etc/rc.d/init.d/squid
install -m 644 $RPM_SOURCE_DIR/squid.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/squid
install -m 644 $RPM_SOURCE_DIR/squid.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/squid

mkdir -p $RPM_BUILD_ROOT/var/log/squid
mkdir -p $RPM_BUILD_ROOT/var/spool/squid

# remove unpackaged files from the buildroot
rm -f $RPM_BUILD_ROOT%{_sbindir}/{RunAccel,RunCache}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir /etc/squid
%config(noreplace) /etc/squid/squid.conf
%config(noreplace) /etc/squid/mime.conf
%config(noreplace) /etc/sysconfig/squid
%config(noreplace) /etc/squid/msntauth.conf
%config /etc/squid/mib.txt
/etc/squid/msntauth.conf.default
/etc/squid/squid.conf.default
/etc/squid/mime.conf.default
%config(noreplace) /etc/squid/errors
/usr/lib/squid
%{_datadir}/squid
/usr/sbin/squid
/usr/sbin/squidclient
%config /etc/rc.d/init.d/squid
%config /etc/logrotate.d/squid
%doc faq/* README ChangeLog QUICKSTART doc/*
#%doc contrib/url-normalizer.pl contrib/rredir.* contrib/user-agents.pl
%attr(750,squid,squid) %dir /var/log/squid
%attr(750,squid,squid) %dir /var/spool/squid
%{_mandir}/man8/*


%pre
/usr/sbin/useradd -u 23 -d /var/spool/squid -r -s /sbin/nologin squid >/dev/null 2>&1

for i in /var/log/squid /var/spool/squid ; do
	if [ -d $i ] ; then
		for adir in `find $i -maxdepth 0 \! -user squid`; do
			chown -R squid.squid $adir
		done
	fi
done

exit 0

%post
/sbin/chkconfig --add squid
if [ $1 = 0 ]; then
 case "$LANG" in
  bg*)
     DIR=Bulgarian
     ;;
  ca*)
     DIR=Catalan
     ;;
  cs*)
     DIR=Czech
     ;;
  da*)
     DIR=Danish
     ;;
  nl*)
     DIR=Dutch
     ;;
  en*)
     DIR=English
     ;;
  ea*)
     DIR=Estonian
     ;;
  fi*)
     DIR=Finnish
     ;;
  fr*)
     DIR=French
     ;;
  de*)
     DIR=German
     ;;
  he*)
     DIR=Hebrew
     ;;
  hu*)
     DIR=Hungarian
     ;;
  it*)
     DIR=Italian
     ;;
  ja*)
     DIR=Japanese
     ;;
  kr*)
     DIR=Korean
     ;;
  pl*)
     DIR=Polish
     ;;
  pt*)
     DIR=Portuguese
     ;;
  ro*)
     DIR=Romanian
     ;;
  ru*)
     DIR=Russian-koi8-r
     ;;
  sr*)
     DIR=Serbian
     ;;
  sk*)
     DIR=Slovak
     ;;
  es*)
     DIR=Spanish
     ;;
  sv*)
     DIR=Swedish
     ;;
  zh_TW*)
     DIR=Traditional_Chinese
     ;;
  zh_CN*)
     DIR=Simplify_Chinese
     ;;
  tr*)
     DIR=Turkish
     ;;
  *)
     DIR=English
     ;;
 esac
 ln -snf %{_datadir}/squid/errors/$DIR /etc/squid/errors
fi

%triggerpostun -- squid < 2.5.STABLE1-1
errordir=`ls -ld /etc/squid/errors | awk '{ print $NF }'`
errordir=${errordir##*/}
ln -snf %{_datadir}/squid/errors/$DIR /etc/squid/errors


%preun
if [ $1 = 0 ] ; then
	service squid stop >/dev/null 2>&1
	rm -f /var/log/squid/*
	/sbin/chkconfig --del squid
fi

%postun
if [ "$1" -ge "1" ] ; then
	service squid condrestart >/dev/null 2>&1
fi

%changelog
* Wed Jun 15 2005 Chip Cuccio <chipster@norlug.org> 2.5STABLE10-1
- updated

* Fri Mar 4 2005 Chip Cuccio <chipster@norlug.org> 2.5STABLE9-1
- updated

* Tue Feb 15 2005 Chip Cuccio <chipster@norlug.org> 2.5STABLE8-1
- updated

* Thu Dec 9 2004 Chip Cuccio <chipster@norlug.org> 2.5STABLE7-2
- added random error messages patch;
  <http://www.squid-cache.org/bugs/show_bug.cgi?id=1143>
- fixed URL field

* Sun Oct 24 2004 Chip Cuccio <chipster@norlug.org> 2.5SABLE7-1
- updated

* Tue Jul 27 2004 Chip Cuccio <chipster@norlug.org> 2.5STABLE6-1
- updated

* Fri May 7 2004 Chip Cuccio <chipster@norlug.org> 2.5STABLE5-1
- update to 2.5STABLE5

* Sun Jan 4 2004 Chip Cuccio <chipster@norlug.org> 2.5STABLE4-2
- patch ftp, gopher, URN, and ERROR files to kill of M$ font refs

* Fri Jan 2 2004 Chip Cuccio <chipster@norlug.org> 2.5STABLE4-1
- initial build for rh-7.3
- include Squid's official patches for 2.5 branch
